## weechat 4.3.1

=== CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
# Copyright (C) 2007-2008 Julien Louis <ptitlouis@sysif.net>
# Copyright (C) 2008-2009 Emmanuel Bouthenot <kolter@openics.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.5)

project(weechat C)

# CMake options
set(CMAKE_VERBOSE_MAKEFILE OFF)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake" "${CMAKE_MODULE_PATH}")
set(CMAKE_SKIP_RPATH ON)

# compiler options
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsigned-char -fms-extensions -Wall -Wextra -Werror-implicit-function-declaration -Wformat -Werror=format-security")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsigned-char -fms-extensions -Wall -Wextra")
if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
  # extra options specific to gcc/g++
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-overflow=2 -Wformat-truncation=2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wformat-overflow=2 -Wformat-truncation=2")
endif()

# version
execute_process(COMMAND "${CMAKE_SOURCE_DIR}/version.sh" devel-major OUTPUT_VARIABLE VERSION_MAJOR)
execute_process(COMMAND "${CMAKE_SOURCE_DIR}/version.sh" devel-minor OUTPUT_VARIABLE VERSION_MINOR)
execute_process(COMMAND "${CMAKE_SOURCE_DIR}/version.sh" devel-patch OUTPUT_VARIABLE VERSION_PATCH)
string(REGEX REPLACE "\n" "" VERSION_MAJOR "${VERSION_MAJOR}")
string(REGEX REPLACE "\n" "" VERSION_MINOR "${VERSION_MINOR}")
string(REGEX REPLACE "\n" "" VERSION_PATCH "${VERSION_PATCH}")
if(VERSION_PATCH STREQUAL "")
  set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}")
else()
  set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
endif()

# license
set(LICENSE "GPL3")

# add definitions for version and license
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0005 NEW)
  add_definitions(-DWEECHAT_VERSION="${VERSION}" -DWEECHAT_LICENSE="${LICENSE}")
else()
  add_definitions(-DWEECHAT_VERSION='"${VERSION}"' -DWEECHAT_LICENSE='"${LICENSE}"')
endif()

# package string
set(PKG_STRING "${PROJECT_NAME} ${VERSION}")
string(REPLACE "\";\"" "\ " PKG_STRING ${PKG_STRING})

if(NOT DEFINED LIBDIR)
  set(LIBDIR "${CMAKE_INSTALL_PREFIX}/lib")
endif()

if(NOT DEFINED WEECHAT_LIBDIR)
  set(WEECHAT_LIBDIR "${LIBDIR}/${PROJECT_NAME}")
endif()

if(NOT DEFINED DATAROOTDIR)
  set(DATAROOTDIR "${CMAKE_INSTALL_PREFIX}/share")
endif()

if(NOT DEFINED WEECHAT_SHAREDIR)
  set(WEECHAT_SHAREDIR "${DATAROOTDIR}/weechat")
endif()

if(NOT DEFINED MANDIR)
  set(MANDIR "${DATAROOTDIR}/man")
endif()

if(NOT DEFINED LOCALEDIR)
  set(LOCALEDIR "${DATAROOTDIR}/locale")
endif()

if(DEFINED INCLUDEDIR)
  set(INCLUDEDIR "${INCLUDEDIR}/${PROJECT_NAME}")
else()
  set(INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME}")
endif()

option(ENABLE_NCURSES        "Compile the Ncurses interface"            ON)
option(ENABLE_HEADLESS       "Compile the headless binary"              ON)
option(ENABLE_NLS            "Enable Native Language Support"           ON)
option(ENABLE_LARGEFILE      "Enable Large File Support"                ON)
option(ENABLE_ZSTD           "Enable Zstandard compression"             ON)
option(ENABLE_CJSON          "Enable cJSON support"                     ON)
option(ENABLE_ALIAS          "Enable Alias plugin"                      ON)
option(ENABLE_BUFLIST        "Enable Buflist plugin"                    ON)
option(ENABLE_CHARSET        "Enable Charset plugin"                    ON)
option(ENABLE_EXEC           "Enable Exec plugin"                       ON)
option(ENABLE_FIFO           "Enable FIFO plugin"                       ON)
option(ENABLE_FSET           "Enable Fast Set plugin"                   ON)
option(ENABLE_IRC            "Enable IRC plugin"                        ON)
option(ENABLE_LOGGER         "Enable Logger plugin"                     ON)
option(ENABLE_RELAY          "Enable Relay plugin"                      ON)
option(ENABLE_SCRIPT         "Enable Script plugin (script manager)"    ON)
option(ENABLE_SCRIPTS        "Enable script plugins (perl, python, …)"  ON)
option(ENABLE_PERL           "Enable Perl scripting language"           ON)
option(ENABLE_PYTHON         "Enable Python scripting language"         ON)
option(ENABLE_RUBY           "Enable Ruby scripting language"           ON)
option(ENABLE_LUA            "Enable Lua scripting language"            ON)
option(ENABLE_TCL            "Enable Tcl scripting language"            ON)
option(ENABLE_GUILE          "Enable Scheme (guile) scripting language" ON)
option(ENABLE_JAVASCRIPT     "Enable JavaScript scripting language"     OFF)
option(ENABLE_PHP            "Enable PHP scripting language"            ON)
option(ENABLE_SPELL          "Enable Spell checker plugin"              ON)
option(ENABLE_ENCHANT        "Use Enchant lib in Spell checker plugin"  OFF)
option(ENABLE_TRIGGER        "Enable Trigger plugin"                    ON)
option(ENABLE_TYPING         "Enable Typing plugin"                     ON)
option(ENABLE_XFER           "Enable Xfer plugin"                       ON)
option(ENABLE_MAN            "Enable build of man page"                 OFF)
option(ENABLE_DOC            "Enable build of documentation"            OFF)
option(ENABLE_DOC_INCOMPLETE "Enable incomplete doc"                    OFF)
option(ENABLE_TESTS          "Enable tests"                             OFF)
option(ENABLE_CODE_COVERAGE  "Enable code coverage"                     OFF)

# code coverage
add_library(coverage_config INTERFACE)
if(ENABLE_CODE_COVERAGE)
  target_compile_options(coverage_config INTERFACE -O0 -g --coverage)
  target_link_libraries(coverage_config INTERFACE --coverage)
endif()

# headless mode is required for documentation
if(ENABLE_DOC AND NOT ENABLE_HEADLESS)
  message(FATAL_ERROR "Headless mode is required to build documentation.")
endif()

# all plugins (except javascript) are required for documentation
if(ENABLE_DOC AND NOT ENABLE_DOC_INCOMPLETE
    AND (NOT ENABLE_NLS OR NOT ENABLE_ALIAS OR NOT ENABLE_BUFLIST
      OR NOT ENABLE_CHARSET OR NOT ENABLE_EXEC OR NOT ENABLE_FIFO
      OR NOT ENABLE_FSET OR NOT ENABLE_IRC OR NOT ENABLE_LOGGER
      OR NOT ENABLE_RELAY OR NOT ENABLE_SCRIPT OR NOT ENABLE_SCRIPTS
      OR NOT ENABLE_PERL OR NOT ENABLE_PYTHON OR NOT ENABLE_RUBY
      OR NOT ENABLE_LUA OR NOT ENABLE_TCL OR NOT ENABLE_GUILE
      OR NOT ENABLE_PHP OR NOT ENABLE_SPELL OR NOT ENABLE_TRIGGER
      OR NOT ENABLE_TYPING OR NOT ENABLE_XFER))
  message(
    FATAL_ERROR
    " All plugins are required to build documentation.\n"
    " If you really want to build incomplete docs, enable this option:\n"
    "   -DENABLE_DOC_INCOMPLETE=ON"
  )
endif()

# headless mode is required for tests
if(ENABLE_TESTS AND NOT ENABLE_HEADLESS)
  message(FATAL_ERROR "Headless mode is required for tests.")
endif()

# option WEECHAT_HOME
set(WEECHAT_HOME "${WEECHAT_HOME}" CACHE
  STRING "Force a single WeeChat home directory for config, logs, scripts, etc."
  FORCE)
mark_as_advanced(CLEAR WEECHAT_HOME)

if(COMMAND cmake_policy)
  if(POLICY CMP0003)
    cmake_policy(SET CMP0003 NEW)
  endif()
  if(POLICY CMP0017)
    cmake_policy(SET CMP0017 NEW)
  endif()
endif()

add_definitions(-DHAVE_CONFIG_H)

include(FindPkgConfig)

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckSymbolExists)

check_include_files("langinfo.h" HAVE_LANGINFO_CODESET)
check_include_files("sys/resource.h" HAVE_SYS_RESOURCE_H)

check_include_files("malloc.h" HAVE_MALLOC_H)
check_symbol_exists("malloc_trim" "malloc.h" HAVE_MALLOC_TRIM)

check_function_exists(mallinfo HAVE_MALLINFO)
check_function_exists(mallinfo2 HAVE_MALLINFO2)

check_symbol_exists("eat_newline_glitch" "term.h" HAVE_EAT_NEWLINE_GLITCH)

# Check for Large File Support
if(ENABLE_LARGEFILE)
  add_definitions(-D_FILE_OFFSET_BITS=64 -D_LARGEFILE64_SOURCE -D_LARGEFILE_SOURCE -D_LARGE_FILES)
endif()

# Check for libgcrypt
pkg_check_modules(LIBGCRYPT REQUIRED libgcrypt)
add_definitions(-DHAVE_GCRYPT)
include_directories(${LIBGCRYPT_INCLUDE_DIRS})
list(APPEND EXTRA_LIBS ${LIBGCRYPT_LDFLAGS})

# Check for GnuTLS
find_package(GnuTLS REQUIRED)
string(REGEX REPLACE "/[^/]*$" "" GNUTLS_LIBRARY_PATH "${GNUTLS_LIBRARY}")
include_directories(${GNUTLS_INCLUDE_PATH})
set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} -L${GNUTLS_LIBRARY_PATH}")
list(APPEND EXTRA_LIBS gnutls)

# Check for zlib
find_package(ZLIB REQUIRED)

# Check for zstd
if(ENABLE_ZSTD)
  pkg_check_modules(LIBZSTD REQUIRED libzstd)
  add_definitions(-DHAVE_ZSTD)
endif()

# Check for cJSON
if(ENABLE_CJSON)
  pkg_check_modules(LIBCJSON REQUIRED libcjson)
  add_definitions(-DHAVE_CJSON)
endif()

# Check for iconv
find_package(Iconv)
if(ICONV_FOUND)
  add_definitions(-DHAVE_ICONV)
endif()

# Check for CURL
find_package(CURL REQUIRED)

# weechat_gui_common MUST be the first lib in the list
set(STATIC_LIBS weechat_gui_common)

find_library(DL_LIBRARY
  NAMES dl
  PATHS /lib /usr/lib /usr/libexec /usr/local/lib /usr/local/libexec
)
list(APPEND STATIC_LIBS weechat_plugins)
if(DL_LIBRARY)
  string(REGEX REPLACE "/[^/]*$" "" DL_LIBRARY_PATH "${DL_LIBRARY}")
  set(CMAKE_C_LINK_FLAGS "${CMAKE_C_LINK_FLAGS} -L${DL_LIBRARY_PATH}")
  list(APPEND EXTRA_LIBS dl)
endif()

add_subdirectory(icons)

if(ENABLE_NLS)
  find_package(Gettext REQUIRED)
  add_definitions(-DENABLE_NLS)
  find_package(Intl REQUIRED)
  list(APPEND EXTRA_LIBS "${Intl_LIBRARIES}")
  add_subdirectory(po)
else()
  add_custom_target(translations COMMAND true)
endif()

add_subdirectory(src)
add_subdirectory(doc)

if(ENABLE_TESTS)
  find_package(CppUTest)
  if(CPPUTEST_FOUND)
    enable_testing()
    add_subdirectory(tests)
  else()
    message(SEND_ERROR "CppUTest not found")
  endif()
else()
  enable_testing()
  add_test(NAME notests COMMAND true)
endif()

configure_file(config.h.cmake config.h @ONLY)

# set the git version in "config-git.h"
add_custom_target(version_git ALL
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/tools/set_git_version.sh" "${CMAKE_CURRENT_SOURCE_DIR}" "${VERSION}" "config-git.h"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY
)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
)

add_custom_target(dist
  "${CMAKE_CURRENT_SOURCE_DIR}/tools/makedist.sh" "${VERSION}" "HEAD" "${CMAKE_CURRENT_BINARY_DIR}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
)

# pkgconfig file
set(PACKAGE "${PROJECT_NAME}")
set(prefix "${CMAKE_INSTALL_PREFIX}")
set(exec_prefix "\${prefix}")
string(REPLACE "${CMAKE_INSTALL_PREFIX}" "\${prefix}" libdir "${LIBDIR}")
set(includedir "\${prefix}/include")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/weechat.pc.in" "${CMAKE_CURRENT_BINARY_DIR}/weechat.pc" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/weechat.pc" DESTINATION "${LIBDIR}/pkgconfig")

# cygport file (used to build Cygwin packages)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/weechat.cygport.in" "${CMAKE_CURRENT_BINARY_DIR}/weechat-${VERSION}-1.cygport" @ONLY)

# install some files (only on Cygwin)
if(CYGWIN)
  install(FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/AUTHORS.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ChangeLog.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/Contributing.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/README.adoc"
    "${CMAKE_CURRENT_SOURCE_DIR}/ReleaseNotes.adoc"

=== doc/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
# Copyright (C) 2009 Emmanuel Bouthenot <kolter@openics.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

if(ENABLE_MAN OR ENABLE_DOC)

  # docs languages
  set(AUTOGEN_LANG de en fr it ja pl sr)
  set(MAN_LANG cs de en fr it ja pl ru sr)
  set(USER_LANG de en fr it ja pl sr)
  set(PLUGIN_API_LANG en fr it ja sr)
  set(SCRIPTING_LANG de en fr it ja pl sr)
  set(FAQ_LANG de en es fr it ja pl sr)
  set(QUICKSTART_LANG cs de en es fr it ja pl ru sr)
  set(RELAY_LANG en fr ja sr)
  set(DEV_LANG en fr ja sr)

  find_package(Asciidoctor)
  if(ASCIIDOCTOR_FOUND)
    # common asciidoctor arguments
    set(ASCIIDOCTOR_ARGS
      -a experimental
      -a reproducible
      -a "prewrap!"
      -a "webfonts!"
      -a icons=font
      -a revnumber="${VERSION}"
      -a sectanchors
      -a source-highlighter=pygments
      -a pygments-style=native
      -a docinfodir="${CMAKE_CURRENT_SOURCE_DIR}"
      -a autogendir="${CMAKE_CURRENT_BINARY_DIR}/autogen"
    )

    # asciidoctor arguments for user's guide
    set(ASCIIDOCTOR_USER_ARGS
      -a toc=left
      -a toclevels=3
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # asciidoctor arguments for plugin API reference
    set(ASCIIDOCTOR_PLUGIN_API_ARGS
      -a toc=left
      -a toclevels=3
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # asciidoctor arguments for scripting guide
    set(ASCIIDOCTOR_SCRIPTING_ARGS
      -a toc=left
      -a toclevels=3
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # asciidoctor arguments for FAQ
    set(ASCIIDOCTOR_FAQ_ARGS
      -a toc=left
      -a toclevels=2
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # asciidoctor arguments for quickstart
    set(ASCIIDOCTOR_QUICKSTART_ARGS
      -a toc=left
      -a toclevels=2
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # asciidoctor arguments for relay protocol
    set(ASCIIDOCTOR_RELAY_ARGS
      -a toc=left
      -a toclevels=3
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # asciidoctor arguments for developer's guide
    set(ASCIIDOCTOR_DEV_ARGS
      -a toc=left
      -a toclevels=3
      -a sectnums
      -a sectnumlevels=2
      -a docinfo1
    )

    # sed arguments used to replace links in ChangeLog and release notes
    set(SED_LINKS_ARGS
      -e "'s/issue #\\([0-9][0-9]*\\)/https:\\/\\/github.com\\/weechat\\/weechat\\/issues\\/\\1[issue #\\1^]/g'"
      -e "'s/bug #\\([0-9][0-9]*\\)/https:\\/\\/savannah.nongnu.org\\/bugs\\/?\\1[bug #\\1^]/g'"
      -e "'s/task #\\([0-9][0-9]*\\)/https:\\/\\/savannah.nongnu.org\\/task\\/?\\1[task #\\1^]/g'"
      -e "'s/patch #\\([0-9][0-9]*\\)/https:\\/\\/savannah.nongnu.org\\/patch\\/?\\1[patch #\\1^]/g'"
      -e "'s/debian #\\([0-9][0-9]*\\)/http:\\/\\/bugs.debian.org\\/cgi-bin\\/bugreport.cgi?bug=\\1[debian bug #\\1^]/g'"
      -e "'s/\\(CVE-[0-9][0-9]*-[0-9][0-9]*\\)/https:\\/\\/cve.mitre.org\\/cgi-bin\\/cvename.cgi?name=\\1[\\1^]/g'"
    )

    # ChangeLog
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/ChangeLog-links.adoc"
      COMMAND sed ARGS ${SED_LINKS_ARGS} "${CMAKE_CURRENT_SOURCE_DIR}/../ChangeLog.adoc" > "${CMAKE_CURRENT_BINARY_DIR}/ChangeLog-links.adoc"
      DEPENDS
      "${CMAKE_CURRENT_SOURCE_DIR}/../ChangeLog.adoc"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/ChangeLog.html"
      COMMAND "${ASCIIDOCTOR_EXECUTABLE}" ARGS ${ASCIIDOCTOR_ARGS} -o ChangeLog.html "${CMAKE_CURRENT_BINARY_DIR}/ChangeLog-links.adoc"
      DEPENDS
      "${CMAKE_CURRENT_SOURCE_DIR}/docinfo.html"
      "${CMAKE_CURRENT_BINARY_DIR}/ChangeLog-links.adoc"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
      COMMENT "Building ChangeLog.html"
    )
    add_custom_target(changelog DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/ChangeLog.html")

    # Release notes
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/ReleaseNotes-links.adoc"
      COMMAND sed ARGS ${SED_LINKS_ARGS} "${CMAKE_CURRENT_SOURCE_DIR}/../ReleaseNotes.adoc" > "${CMAKE_CURRENT_BINARY_DIR}/ReleaseNotes-links.adoc"
      DEPENDS
      "${CMAKE_CURRENT_SOURCE_DIR}/../ReleaseNotes.adoc"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    )
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/ReleaseNotes.html"
      COMMAND "${ASCIIDOCTOR_EXECUTABLE}" ARGS ${ASCIIDOCTOR_ARGS} -o ReleaseNotes.html "${CMAKE_CURRENT_BINARY_DIR}/ReleaseNotes-links.adoc"
      DEPENDS
      "${CMAKE_CURRENT_SOURCE_DIR}/docinfo.html"
      "${CMAKE_CURRENT_BINARY_DIR}/ReleaseNotes-links.adoc"
      WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
      COMMENT "Building ReleaseNotes.html"
    )
    add_custom_target(rn DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/ReleaseNotes.html")

    if(ENABLE_DOC)
      set(AUTOGEN_FILES "")
      foreach(lang ${AUTOGEN_LANG})
        LIST(APPEND AUTOGEN_FILES
          # plugin API reference
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_completions.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_config_priority.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_hdata.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_infolists.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_infos.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_infos_hashtable.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_plugins_priority.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_url_options.${lang}.adoc"
          # user's guide
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_commands.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_default_aliases.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_irc_colors.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_options.${lang}.adoc"
          # scripting duide
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_scripting_functions.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_scripting_constants.${lang}.adoc"
        )
      endforeach()
      add_custom_target(doc-autogen ALL
        COMMAND "${CMAKE_COMMAND}" -E env "WEECHAT_EXTRA_LIBDIR=${PROJECT_BINARY_DIR}/src" "WEECHAT_DOCGEN_LOCALEDIR=${PROJECT_BINARY_DIR}/po" "${CMAKE_BINARY_DIR}/src/gui/curses/headless/weechat-headless" --temp-dir --doc-gen "${CMAKE_CURRENT_BINARY_DIR}/autogen"
        DEPENDS
        # the headless binary is required
        weechat-headless
        # translations must be compiled
        translations
        # all plugins must be loaded during doc generation
        alias buflist charset exec fifo fset guile irc logger lua perl php python relay ruby script spell tcl trigger typing xfer
        BYPRODUCTS ${AUTOGEN_FILES}
        WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
      )
    endif()

    if(ENABLE_MAN)
      foreach(lang ${MAN_LANG})
        if(${lang} STREQUAL "en")
          set(MANDIR_LANG "${MANDIR}/man1")
        else()
          set(MANDIR_LANG "${MANDIR}/${lang}/man1")
        endif()
        # man page: weechat
        add_custom_command(
          OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/weechat.${lang}.1"
          COMMAND "${ASCIIDOCTOR_EXECUTABLE}" ARGS ${ASCIIDOCTOR_ARGS} -b manpage -o "weechat.${lang}.1" "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat.1.${lang}.adoc"
          DEPENDS
          "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat.1.${lang}.adoc"
          "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/includes/cmdline_options.${lang}.adoc"
          "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/includes/man.${lang}.adoc"
          WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
          COMMENT "Building weechat.1 (${lang})"
        )
        add_custom_target(doc-man-weechat-${lang} ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/weechat.${lang}.1")
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/weechat.${lang}.1" DESTINATION "${MANDIR_LANG}" RENAME "weechat.1")
        # man page: weechat-headless
        if(ENABLE_HEADLESS)
          add_custom_command(
            OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/weechat-headless.${lang}.1"
            COMMAND "${ASCIIDOCTOR_EXECUTABLE}" ARGS ${ASCIIDOCTOR_ARGS} -b manpage -o "weechat-headless.${lang}.1" "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat-headless.1.${lang}.adoc"
            DEPENDS
            "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat-headless.1.${lang}.adoc"
            "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/includes/cmdline_options.${lang}.adoc"
            "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/includes/man.${lang}.adoc"
            WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
            COMMENT "Building weechat-headless.1 (${lang})"
          )
          add_custom_target(doc-man-weechat-headless-${lang} ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/weechat-headless.${lang}.1")
          install(FILES "${CMAKE_CURRENT_BINARY_DIR}/weechat-headless.${lang}.1" DESTINATION "${MANDIR_LANG}" RENAME "weechat-headless.1")
        endif()
      endforeach()
    endif()

    if(ENABLE_DOC)
      # user's guide
      foreach(lang ${USER_LANG})
        add_custom_command(
          OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/weechat_user.${lang}.html"
          COMMAND "${ASCIIDOCTOR_EXECUTABLE}" ARGS ${ASCIIDOCTOR_ARGS} ${ASCIIDOCTOR_USER_ARGS} -o "weechat_user.${lang}.html" "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat_user.${lang}.adoc"
          DEPENDS
          "${CMAKE_CURRENT_SOURCE_DIR}/docinfo.html"
          "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat_user.${lang}.adoc"
          "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/includes/cmdline_options.${lang}.adoc"
          doc-autogen
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_commands.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_default_aliases.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_irc_colors.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_user_options.${lang}.adoc"
          WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
          COMMENT "Building weechat_user.${lang}.html"
        )
        add_custom_target(doc-user-${lang} ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/weechat_user.${lang}.html")
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/weechat_user.${lang}.html" DESTINATION "${DATAROOTDIR}/doc/${PROJECT_NAME}")
      endforeach()
      # plugin API reference
      foreach(lang ${PLUGIN_API_LANG})
        add_custom_command(
          OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/weechat_plugin_api.${lang}.html"
          COMMAND "${ASCIIDOCTOR_EXECUTABLE}" ARGS ${ASCIIDOCTOR_ARGS} ${ASCIIDOCTOR_PLUGIN_API_ARGS} -o "weechat_plugin_api.${lang}.html" "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat_plugin_api.${lang}.adoc"
          DEPENDS
          "${CMAKE_CURRENT_SOURCE_DIR}/docinfo.html"
          "${CMAKE_CURRENT_SOURCE_DIR}/${lang}/weechat_plugin_api.${lang}.adoc"
          doc-autogen
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_completions.${lang}.adoc"
          "${CMAKE_CURRENT_BINARY_DIR}/autogen/autogen_api_config_priority.${lang}.adoc"

=== po/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

# Check for programs xgettext, msgmerge and msgfmt
find_program(XGETTEXT_EXECUTABLE xgettext REQUIRED)
find_program(MSGMERGE_EXECUTABLE msgmerge REQUIRED)
find_program(MSGFMT_EXECUTABLE msgfmt REQUIRED)

set(PO_FILES
  cs.po
  de.po
  es.po
  fr.po
  hu.po
  it.po
  ja.po
  pl.po
  pt.po
  pt_BR.po
  ru.po
  sr.po
  tr.po
)

set(BUGS_ADDRESS "flashcode@flashtux.org")
set(POT_FILE "${PROJECT_NAME}.pot")
set(POT_FILE_PATH "${CMAKE_CURRENT_BINARY_DIR}/${POT_FILE}")

include(srcfiles.cmake)

# Create PO template file weechat.pot
set(SRC_FILES)
set(POT_DEPENDS)

foreach(srcfile ${WEECHAT_SOURCES})
  set(SRC_FILES ${SRC_FILES} ${srcfile})
  set(POT_DEPENDS ${POT_DEPENDS} "${CMAKE_SOURCE_DIR}/${srcfile}")
endforeach()

add_custom_command(
  OUTPUT "${POT_FILE_PATH}"
  COMMAND "${XGETTEXT_EXECUTABLE}"
  ARGS -o "${POT_FILE_PATH}" --add-comments='TRANSLATORS:' --keyword='_' --keyword='weechat_gettext' --keyword='N_' --keyword='NG_:1,2' --keyword='weechat_ngettext:1,2' --no-location --from-code=UTF-8 --directory="${CMAKE_SOURCE_DIR}" --package-name='WeeChat' --package-version=${VERSION} --msgid-bugs-address=${BUGS_ADDRESS} --copyright-holder='NAME' ${SRC_FILES}
  DEPENDS ${POT_DEPENDS}
  COMMENT "Generating ${POT_FILE}"
)

set(MO_FILES)
set(UPDATE_PO_TARGETS)
foreach(pofile ${PO_FILES})
  get_filename_component(polang ${pofile} NAME_WE)

  # Compile .po files in build directory (to binary .mo files)
  set(modir "${CMAKE_CURRENT_BINARY_DIR}/${polang}/LC_MESSAGES")
  file(MAKE_DIRECTORY "${modir}")
  set(mofile "${modir}/${PROJECT_NAME}.mo")
  add_custom_command(
    OUTPUT "${mofile}"
    COMMAND "${MSGMERGE_EXECUTABLE}" ARGS --quiet -o "${CMAKE_CURRENT_BINARY_DIR}/${pofile}" "${CMAKE_CURRENT_SOURCE_DIR}/${pofile}" ${POT_FILE_PATH}
    COMMAND "${MSGFMT_EXECUTABLE}" ARGS -o "${mofile}" "${CMAKE_CURRENT_BINARY_DIR}/${pofile}"
    COMMAND "${MSGFMT_EXECUTABLE}" ARGS -c --statistics --verbose --output-file=/dev/null "${CMAKE_CURRENT_BINARY_DIR}/${pofile}"
    DEPENDS "${POT_FILE_PATH}" "${CMAKE_CURRENT_SOURCE_DIR}/${pofile}"
    COMMENT "Compiling ${polang}.po"
  )

  # Update .po files in source directory (if needed)
  add_custom_target(
    update-${pofile}
    COMMAND "${MSGMERGE_EXECUTABLE}" --quiet --update --previous --backup=none "${CMAKE_CURRENT_SOURCE_DIR}/${pofile}" "${POT_FILE_PATH}"
    COMMENT "Updating ${polang}.po"
  )
  set(UPDATE_PO_TARGETS ${UPDATE_PO_TARGETS} update-${pofile})

  install(FILES "${mofile}" DESTINATION "${LOCALEDIR}/${polang}/LC_MESSAGES")
  set(MO_FILES ${MO_FILES} ${mofile})
endforeach()

add_custom_target(translations ALL DEPENDS ${MO_FILES})

# Update weechat.pot in source directory (if needed)
add_custom_target(
  update-${POT_FILE}
  COMMAND "${MSGMERGE_EXECUTABLE}" --quiet --update --backup=none "${CMAKE_CURRENT_SOURCE_DIR}/${POT_FILE}" "${POT_FILE_PATH}"
  COMMENT "Updating ${POT_FILE}"
)

# Update all .po and weechat.pot in source directory (if needed)
add_custom_target(update-po DEPENDS update-${POT_FILE} ${UPDATE_PO_TARGETS})

=== src/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
# Copyright (C) 2007-2008 Julien Louis <ptitlouis@sysif.net>
# Copyright (C) 2008-2009 Emmanuel Bouthenot <kolter@openics.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_subdirectory(core)
list(APPEND STATIC_LIBS weechat_core)

add_subdirectory(plugins)

add_subdirectory(gui)

=== src/core/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
# Copyright (C) 2008 Julien Louis <ptitlouis@sysif.net>
# Copyright (C) 2009 Emmanuel Bouthenot <kolter@openics.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

set(LIB_CORE_SRC
  weechat.c weechat.h
  core-arraylist.c core-arraylist.h
  core-backtrace.c core-backtrace.h
  core-calc.c core-calc.h
  core-command.c core-command.h
  core-completion.c core-completion.h
  core-config.c core-config.h
  core-config-file.c core-config-file.h
  core-crypto.c core-crypto.h
  core-debug.c core-debug.h
  core-dir.c core-dir.h
  core-doc.c core-doc.h
  core-eval.c core-eval.h
  core-hashtable.c core-hashtable.h
  core-hdata.c core-hdata.h
  core-hook.c core-hook.h
  core-infolist.c core-infolist.h
  core-input.c core-input.h
  core-list.c core-list.h
  core-log.c core-log.h
  core-network.c core-network.h
  core-proxy.c core-proxy.h
  core-secure.c core-secure.h
  core-secure-buffer.c core-secure-buffer.h
  core-secure-config.c core-secure-config.h
  core-signal.c core-signal.h
  core-string.c core-string.h
  core-sys.c core-sys.h
  core-upgrade.c core-upgrade.h
  core-upgrade-file.c core-upgrade-file.h
  core-url.c core-url.h
  core-utf8.c core-utf8.h
  core-util.c core-util.h
  core-version.c core-version.h
  hook/hook-command-run.c hook/hook-command-run.h
  hook/hook-command.c hook/hook-command.h
  hook/hook-completion.c hook/hook-completion.h
  hook/hook-config.c hook/hook-config.h
  hook/hook-connect.c hook/hook-connect.h
  hook/hook-fd.c hook/hook-fd.h
  hook/hook-focus.c hook/hook-focus.h
  hook/hook-hdata.c hook/hook-hdata.h
  hook/hook-hsignal.c hook/hook-hsignal.h
  hook/hook-info-hashtable.c hook/hook-info-hashtable.h
  hook/hook-info.c hook/hook-info.h
  hook/hook-infolist.c hook/hook-infolist.h
  hook/hook-line.c hook/hook-line.h
  hook/hook-modifier.c hook/hook-modifier.h
  hook/hook-print.c hook/hook-print.h
  hook/hook-process.c hook/hook-process.h
  hook/hook-signal.c hook/hook-signal.h
  hook/hook-timer.c hook/hook-timer.h
  hook/hook-url.c hook/hook-url.h
)

# Check for flock support
include(CheckSymbolExists)
check_symbol_exists(flock "sys/file.h" HAVE_FLOCK)

if(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
  find_library(EXECINFO_LIB_PATH execinfo /usr/local/lib)
  set(CMAKE_REQUIRED_LIBRARIES "${EXECINFO_LIB_PATH}")
  check_function_exists(backtrace HAVE_BACKTRACE)
else()
  check_symbol_exists(backtrace "execinfo.h" HAVE_BACKTRACE)
endif()

include_directories(${GNUTLS_INCLUDE_PATH})

include_directories(${CURL_INCLUDE_DIRS})

if(ENABLE_ZSTD)
  include_directories(${LIBZSTD_INCLUDE_DIRS})
endif()

if(ENABLE_CJSON)
  include_directories(${LIBCJSON_INCLUDE_DIRS})
endif()

include_directories("${CMAKE_BINARY_DIR}")
add_library(weechat_core STATIC ${LIB_CORE_SRC})
target_link_libraries(weechat_core coverage_config)
add_dependencies(weechat_core version_git)

=== src/plugins/exec/CMakeLists.txt ===
#
# Copyright (C) 2014-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(exec MODULE
  exec.c exec.h
  exec-buffer.c exec-buffer.h
  exec-command.c exec-command.h
  exec-completion.c exec-completion.h
  exec-config.c exec-config.h
)
set_target_properties(exec PROPERTIES PREFIX "")

target_link_libraries(exec coverage_config)

install(TARGETS exec LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/plugins/irc/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(irc MODULE
  irc.c irc.h
  irc-bar-item.c irc-bar-item.h
  irc-batch.c irc-batch.h
  irc-buffer.c irc-buffer.h
  irc-channel.c irc-channel.h
  irc-color.c irc-color.h
  irc-command.c irc-command.h
  irc-completion.c irc-completion.h
  irc-config.c irc-config.h
  irc-ctcp.c irc-ctcp.h
  irc-debug.c irc-debug.h
  irc-ignore.c irc-ignore.h
  irc-info.c irc-info.h
  irc-input.c irc-input.h
  irc-list.c irc-list.h
  irc-join.c irc-join.h
  irc-message.c irc-message.h
  irc-mode.c irc-mode.h
  irc-modelist.c irc-modelist.h
  irc-msgbuffer.c irc-msgbuffer.h
  irc-nick.c irc-nick.h
  irc-notify.c irc-notify.h
  irc-protocol.c irc-protocol.h
  irc-raw.c irc-raw.h
  irc-redirect.c irc-redirect.h
  irc-sasl.c irc-sasl.h
  irc-server.c irc-server.h
  irc-tag.c irc-tag.h
  irc-typing.c irc-typing.h
  irc-upgrade.c irc-upgrade.h
)
set_target_properties(irc PROPERTIES PREFIX "")

set(LINK_LIBS)

include_directories(${GNUTLS_INCLUDE_PATH})
list(APPEND LINK_LIBS ${GNUTLS_LIBRARY})

list(APPEND LINK_LIBS ${LIBGCRYPT_LDFLAGS})

if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  # link with resolv lib on macOS
  list(APPEND LINK_LIBS "resolv")
endif()

target_link_libraries(irc ${LINK_LIBS} coverage_config)

install(TARGETS irc LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/plugins/javascript/CMakeLists.txt ===
#
# Copyright (C) 2015-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

enable_language(CXX)

add_library(javascript MODULE
  weechat-js.cpp weechat-js.h
  weechat-js-v8.cpp weechat-js-v8.h
  weechat-js-api.cpp weechat-js-api.h
)
set_target_properties(javascript PROPERTIES PREFIX "")

if(V8_FOUND)
  include_directories(${V8_INCLUDE_DIR})
  target_link_libraries(javascript ${V8_LIBRARY} weechat_plugins_scripts coverage_config)
endif()

install(TARGETS javascript LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/plugins/perl/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(perl MODULE
  weechat-perl.c weechat-perl.h
  weechat-perl-api.c weechat-perl-api.h
)
set_target_properties(perl PROPERTIES PREFIX "")

if(PERL_FOUND)
  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    # remove "-arch xxx" on macOS
    STRING(REGEX REPLACE "-arch ppc|-arch i386|-arch x86_64" "" PERL_CFLAGS "${PERL_CFLAGS}")
    STRING(REGEX REPLACE "-arch ppc|-arch i386|-arch x86_64" "" PERL_LFLAGS "${PERL_LFLAGS}")
  endif()
  add_definitions(${PERL_CFLAGS})
  include_directories(${PERL_INCLUDE_PATH})
  # ugly hack to force linking against Dynaloader.a
  string(REGEX MATCH "/[^ $]*/DynaLoader.a" PERL_DYNALOADER ${PERL_LFLAGS})
  if(PERL_DYNALOADER)
    string(REPLACE "${PERL_DYNALOADER}" "" PERL_LFLAGS "${PERL_LFLAGS}")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${PERL_LFLAGS}")
    execute_process(COMMAND ${CMAKE_COMMAND} -E copy ${PERL_DYNALOADER} ${CMAKE_CURRENT_BINARY_DIR}/libDynaLoader.a)
    target_link_libraries(perl ${PERL_LIBRARY} weechat_plugins_scripts ${CMAKE_CURRENT_BINARY_DIR}/libDynaLoader.a coverage_config)
  else()
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${PERL_LFLAGS}")
    target_link_libraries(perl ${PERL_LIBRARY} weechat_plugins_scripts coverage_config)
  endif()
endif()

install(TARGETS perl LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/plugins/ruby/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(ruby MODULE
  weechat-ruby.c weechat-ruby.h
  weechat-ruby-api.c weechat-ruby-api.h
)
set_target_properties(ruby PROPERTIES PREFIX "")

if(RUBY_FOUND)
  # temporary fix: ignore all warnings on unused parameters due to warnings
  # caused by Ruby headers (with Ruby ≥ 3.1.0)
  # see: https://github.com/ruby/ruby/pull/7085
  add_definitions(-Wno-unused-parameter)
  include_directories(${RUBY_INCLUDE_DIRS})
  target_link_libraries(ruby ${RUBY_LDFLAGS} weechat_plugins_scripts coverage_config)
endif(RUBY_FOUND)

install(TARGETS ruby LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/plugins/tcl/CMakeLists.txt ===
#
# Copyright (C) 2008-2010 Dmitry Kobylin <fnfal@academ.tsc.ru>
# Copyright (C) 2008 Julien Louis <ptitlouis@sysif.net>
# Copyright (C) 2008-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

add_library(tcl MODULE
  weechat-tcl.c weechat-tcl.h
  weechat-tcl-api.c weechat-tcl-api.h
)
set_target_properties(tcl PROPERTIES PREFIX "")

if(TCL_FOUND)
  set(CMAKE_REQUIRED_INCLUDES "${TCL_INCLUDE_PATH}")
  set(CMAKE_REQUIRED_LIBRARIES "${TCL_LIBRARY}")
  include_directories(${TCL_INCLUDE_PATH})
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${TCL_LFLAGS}")
  target_link_libraries(tcl ${TCL_LIBRARY} weechat_plugins_scripts coverage_config)
endif()

install(TARGETS tcl LIBRARY DESTINATION "${WEECHAT_LIBDIR}/plugins")

=== src/gui/curses/normal/CMakeLists.txt ===
#
# Copyright (C) 2003-2024 Sébastien Helleu <flashcode@flashtux.org>
#
# This file is part of WeeChat, the extensible chat client.
#
# WeeChat is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# WeeChat is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with WeeChat.  If not, see <https://www.gnu.org/licenses/>.
#

set(LIB_GUI_CURSES_SRC
  ../gui-curses.h
  ../gui-curses-bar-window.c ../gui-curses-bar-window.h
  ../gui-curses-chat.c ../gui-curses-chat.h
  ../gui-curses-color.c ../gui-curses-color.h
  ../gui-curses-key.c ../gui-curses-key.h
  ../gui-curses-main.c ../gui-curses-main.h
  ../gui-curses-mouse.c ../gui-curses-mouse.h
  ../gui-curses-term.c
  ../gui-curses-window.c ../gui-curses-window.h
)

find_package(Ncurses)
if(NCURSES_FOUND)
  check_include_files(ncursesw/ncurses.h NCURSESW_HEADERS)
  if(NCURSESW_HEADERS)
    add_definitions(-DHAVE_NCURSESW_CURSES_H)
  else()
    check_include_files(ncurses.h NCURSES_HEADERS)
    if(NCURSES_HEADERS)
      add_definitions(-DHAVE_NCURSES_H)
    endif()
  endif()
else()
  message(SEND_ERROR "Ncurses not found")
endif()

include_directories(.. ../../core ../../plugins ${NCURSES_INCLUDE_PATH})

add_library(weechat_gui_curses_normal STATIC ${LIB_GUI_CURSES_SRC})

set(WEECHAT_CURSES_MAIN_SRC main.c)

set(EXECUTABLE weechat)

add_executable(${EXECUTABLE} ${WEECHAT_CURSES_MAIN_SRC})

add_dependencies(${EXECUTABLE} weechat_gui_curses_normal)

list(APPEND EXTRA_LIBS ${NCURSES_LIBRARY})

# Due to circular references, we must link two times with libweechat_core.a and libweechat_gui_common.a
target_link_libraries(${EXECUTABLE} ${STATIC_LIBS} weechat_gui_curses_normal ${EXTRA_LIBS} ${STATIC_LIBS} coverage_config)

# Create a symbolic link weechat-curses -> weechat
# This link is created for compatibility with old versions on /upgrade.
# It may be removed in future.
add_custom_command(
  TARGET ${EXECUTABLE}
  COMMAND ${CMAKE_COMMAND} -E remove -f "weechat-curses${CMAKE_EXECUTABLE_SUFFIX}"
  COMMAND ${CMAKE_COMMAND} -E create_symlink "weechat${CMAKE_EXECUTABLE_SUFFIX}" "weechat-curses${CMAKE_EXECUTABLE_SUFFIX}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  COMMENT "Creating symbolic link ${EXECUTABLE}-curses${CMAKE_EXECUTABLE_SUFFIX}"
)
list(APPEND CMAKE_INSTALL_MANIFEST_FILES "${CMAKE_INSTALL_PREFIX}/bin/weechat-curses${CMAKE_EXECUTABLE_SUFFIX}")

# Install executable and symbolic link
install(TARGETS ${EXECUTABLE} RUNTIME DESTINATION bin)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/${EXECUTABLE}-curses${CMAKE_EXECUTABLE_SUFFIX}" DESTINATION bin)

=== debian/changelog ===
weechat (4.3.1-1) unstable; urgency=medium

  * New upstream release (Closes: #1067608)
    - fix FTBFS against libgcrypt 1.11 (Closes: #1071960)
  * Add build dependency on libcjson-dev
  * Replace pkg-config build dependency by pkgconf
  * Minor updates in debian/copyright

 -- Emmanuel Bouthenot <kolter@debian.org>  Sat, 01 Jun 2024 14:21:02 +0000

=== debian/control ===
Source: weechat
Section: net
Priority: optional
Maintainer: Emmanuel Bouthenot <kolter@debian.org>
Build-Depends:
    asciidoctor (>= 1.5.4),
    debhelper (>= 13),
    debhelper-compat (= 13),
    cmake,
    pkgconf,
    libncurses-dev,
    ruby-dev,
    libperl-dev,
    python3-dev,
    libaspell-dev,
    liblua5.3-dev,
    tcl8.6-dev,
    guile-3.0-dev,
    php-dev, libphp-embed, libargon2-dev, libsodium-dev,
    libxml2-dev,
    libcurl4-gnutls-dev,
    libgcrypt20-dev,
    libgnutls28-dev,
    libzstd-dev,
    zlib1g-dev,
    libcjson-dev
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://weechat.org/
Vcs-Git: https://salsa.debian.org/kolter/weechat.git
Vcs-Browser: https://salsa.debian.org/kolter/weechat

Package: weechat
Architecture: all
Depends:
    ${misc:Depends},
    weechat-curses (>= ${source:Version}) | weechat-headless (>= ${source:Version})
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client (metapackage)
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 It is customizable and extensible with plugins/scripts, and includes:
  - support of IRC protocol (native)
  - support of XMPP/Jabber protocol (with additional script)
  - nicklist
  - smart hotlist
  - horizontal and vertical split
  - double charset support (decode/encode)
  - FIFO pipe for remote control
  - 256 colors support
  - incremental text search
  - dynamic filtering of buffer content
  - Perl, Python, Ruby, Lua, Tcl, Scheme and PHP scripting
  - script manager
  - spell checking
  - highly customizable and extensible
  - and much more!

Package: weechat-curses
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-core (= ${binary:Version})
Recommends:
    weechat-plugins (= ${binary:Version})
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client - console client
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 It is customizable and extensible with plugins/scripts, and includes:
  - support of IRC protocol (native)
  - support of XMPP/Jabber protocol (with additional script)
  - nicklist
  - smart hotlist
  - horizontal and vertical split
  - double charset support (decode/encode)
  - FIFO pipe for remote control
  - 256 colors support
  - incremental text search
  - dynamic filtering of buffer content
  - Perl, Python, Ruby, Lua, Tcl, Scheme and PHP scripting
  - script manager
  - spell checking
  - highly customizable and extensible
  - and much more!
 .
 This package provides the console client (ncurses).

Package: weechat-headless
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-core (= ${binary:Version})
Recommends: weechat-plugins (= ${binary:Version})
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client - headless client
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 It is customizable and extensible with plugins/scripts, and includes:
  - support of IRC protocol (native)
  - support of XMPP/Jabber protocol (with additional script)
  - nicklist
  - smart hotlist
  - horizontal and vertical split
  - double charset support (decode/encode)
  - FIFO pipe for remote control
  - 256 colors support
  - incremental text search
  - dynamic filtering of buffer content
  - Perl, Python, Ruby, Lua, Tcl, Scheme and PHP scripting
  - script manager
  - spell checking
  - highly customizable and extensible
  - and much more!
 .
 This package provides the headless client.

Package: weechat-core
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends}
Suggests: weechat-doc (= ${source:Version})
Description: Fast, light and extensible chat client - core files
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides core plugins and locales files for WeeChat. It
 currently ships the following plugins: alias, buflist, charset, fset, irc,
 logger and xfer. It is useless without weechat-curses or weechat-headless.

Package: weechat-plugins
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Recommends:
    weechat-perl,
    weechat-python,
    weechat-ruby
Suggests: weechat-scripts (>> 20090221-1)
Description: Fast, light and extensible chat client - plugins
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides some plugins to enhance WeeChat. It currently
 ships the following plugins:
  - script manager
  - Spell checking (thanks to aspell)
  - FIFO pipe for remote control
  - Relay (IRC proxy and WeeChat protocol)
  - Trigger
  - Typing

Package: weechat-python
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Python 3 plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Python 3 scripting API plugin.

Package: weechat-perl
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Perl plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Perl scripting API plugin.

Package: weechat-ruby
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Ruby plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Ruby scripting API plugin.

Package: weechat-lua
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Lua plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Lua scripting API plugin.

Package: weechat-tcl
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Tcl plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Tcl scripting API plugin.

Package: weechat-guile
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version})
Description: Fast, light and extensible chat client - Guile plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the Guile scripting API plugin.

Package: weechat-php
Architecture: any
Depends:
    ${misc:Depends},
    ${shlibs:Depends},
    weechat-curses (= ${binary:Version}) | weechat-headless (= ${binary:Version}),
    libphp-embed
Description: Fast, light and extensible chat client - PHP plugin
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package provides the PHP scripting API plugin.

Package: weechat-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Fast, light and extensible chat client - documentation
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package contains the html documentation for WeeChat.

Package: weechat-dev
Section: devel
Architecture: any
Depends: ${misc:Depends}
Description: Fast, light and extensible chat client - development headers
 WeeChat (Wee Enhanced Environment for Chat) is a fast and light chat client
 for many operating systems. Everything can be done with a keyboard.
 .
 This package contains the headers needed to build plugins.
